# Clojurecember

In which I attempt to learn at least a little bit of Clojure with the end goal
of writing a text editor, even if it's just about one standard library data
structure, each day of December.

## DEC01

Installed Clojure and followed the [Clojure Syntax Learning
Guide](https://www.clojure.org/guides/learn/syntax).

## DEC02

Continued following the Clojure Guide with
[Functions](https://www.clojure.org/guides/learn/functions).

## DEC03

Finished up with Functions in Clojure and moved on to
[Sequential](https://www.clojure.org/guides/learn/sequential_colls) and
[Hashed](https://www.clojure.org/guides/learn/hashed_colls) collections.

## DEC04

Moved onto learning Clojure [Flow
Control](https://www.clojure.org/guides/learn/flow) and
[Namespaces](https://www.clojure.org/guides/learn/namespaces) which finishes
off learning the basics of Clojure.

## DEC05

Installed [leiningen](https://codeberg.org/leiningen/leiningen) which is
apparently Clojure's version of `pip`, `npm`, etc. Created a new project which
uses [Seesaw](https://github.com/clj-commons/seesaw/) and made a basic program
that spawns a window that lets you type text in.

## DEC06

Added a menu bar with some basic actions (File -> [New, Open, Save, Quit]),
(Edit -> [Copy, Cut, Paste]), and (Help -> [About]) to the text editor.

## DEC07

Improved the save features of the text editor: added a Save As and made the New
option make an entirely new file, instead of just blanking the text area. Also
added some labels for the current file and some feedback when a file was saved,
opened, etc.

## DEC21

Played around with trying to get a line count side-bar thing (like vim's `numbers`).

## DEC22

Made progress on the line count functionality, decided that it was not really possible or would be too awkward with (how I understand this) GUI framework. What kind of text editor needs a line count anyways?
